/*
 * Copyright (C) 2009 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gameproject.multiplayerpaddle;

//import com.gameproject.tabletpaddle.GameView;

import android.annotation.TargetApi;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.view.inputmethod.EditorInfo;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

/**
 * To główna Aktywność wyświetlając bieżącą sesję komunikacji.
 */
@TargetApi(11)
public class BluetoothChat extends Activity {
    // Debugowanie
    private static final String TAG = "BluetoothChat";
    private static final boolean D = true;

    // Rodzaje komunikatów wysyłane do procedury BluetoothChatService
    public static final int MESSAGE_STATE_CHANGE = 1;
    public static final int MESSAGE_READ = 2;
    public static final int MESSAGE_WRITE = 3;
    public static final int MESSAGE_DEVICE_NAME = 4;
    public static final int MESSAGE_TOAST = 5;

    // Klucze nazw otrzymywanych z procedury BluetoothChatService
    public static final String DEVICE_NAME = "device_name";
    public static final String TOAST = "toast";

    // Kody żądań
    private static final int REQUEST_CONNECT_DEVICE = 1;
    private static final int REQUEST_ENABLE_BT = 2;

    // Widoki
    private TextView mTitle;
    private ListView mConversationView;
    private EditText mOutEditText;
    private Button mSendButton;

    
	GameView mGameView;
	
    // Nazwa połączonego urządzenia
    private String mConnectedDeviceName = null;
    // Tablica przechowująca treść komunikacji
    private ArrayAdapter<String> mConversationArrayAdapter;
    // Bufor wiadomości wychodzących
    private StringBuffer mOutStringBuffer;
    // Lokalny adapter Bluetooth
    private BluetoothAdapter BlueAdapter = null;
    // Obiekt usługi komunikacji
    private BluetoothChatService mChatService = null;


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if(D) Log.e(TAG, "+++ ON CREATE +++");
        



        Log.e("GAMEVIEW","GAMEVIEW Hzaincjalizowana!!!");
        

        // Utwórz główne okno
        requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
        getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.custom_title);

        // Utwórz tytuł okna
       // mTitle = (TextView) findViewById(R.id.title_left_text);
       // mTitle.setText(R.string.app_name);
       // mTitle = (TextView) findViewById(R.id.title_right_text);

        BlueAdapter = BluetoothAdapter.getDefaultAdapter();

        if (BlueAdapter == null) {
            Toast.makeText(this, "Interfejs Bluetooth nie jest dostępny", Toast.LENGTH_LONG).show();
            return;
        }
    }

    @Override
    public void onStart() {
        super.onStart();
        if(D) Log.e(TAG, "++ ON START ++");

        // Jeżeli interfejs nie jest włączony zażądaj jego włączenia.
        // następnei wywołaj setupChat() podczas onActivityResult
        if (!BlueAdapter.isEnabled()) {
            Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
        // W przeciwnym wypadku skonfiguruj sesję komunikacji
        } else {
            if (mChatService == null) startgame();
        }
    }

    @Override
    public synchronized void onResume() {
        super.onResume();
        if(D) Log.e(TAG, "+ ON RESUME +");

        // Wykonanie tego testu w trakcie onResume() obsługuje przypadek w którym Bluetooth
        // nie był aktywny w trakcie onStart(), dlatego konieczne było spauzowanei programu...
        // onResume() będzie wywołana w momencie otrzymania ACTION_REQUEST_ENABLE .
        if (mChatService != null) {
            // Jedynie gdy stan jest STATE_NONE, Czy wiemy że komunikacja nie została już rozpoczęta?
            if (mChatService.getState() == BluetoothChatService.STATE_NONE) {
              // Uruchom usługi komunikacji
              mChatService.start();
            }
        }
    }

    private void startgame() {
        Log.d(TAG, "setupChat()");

        mGameView = new GameView(this, mHandler);
        setContentView(mGameView);
        

    }

    @Override
    public synchronized void onPause() {
        super.onPause();
        if(D) Log.e(TAG, "- ON PAUSE -");
    }

    @Override
    public void onStop() {
        super.onStop();
        if(D) Log.e(TAG, "-- ON STOP --");
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        // Zatrzymaj usługi komunikacji
        if (mChatService != null) mChatService.stop();
        if(D) Log.e(TAG, "--- ON DESTROY ---");
    }

    private void ensureDiscoverable() {
        if(D) Log.d(TAG, "zapewnij wykrywalność");
        if (BlueAdapter.getScanMode() !=
            BluetoothAdapter.SCAN_MODE_CONNECTABLE_DISCOVERABLE) {
            Intent discoverableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_DISCOVERABLE);
            discoverableIntent.putExtra(BluetoothAdapter.EXTRA_DISCOVERABLE_DURATION, 300);
            startActivity(discoverableIntent);
        }
    }

    /**
     * Wysyła komunikat
     * @param message  Łańcuch tekstowy do wysłania.
     */
    private void sendMessage(String message) {
        // Przed rozpoczęciem czegokolwiek sprawdź połączenie
        if (mChatService.getState() != BluetoothChatService.STATE_CONNECTED) {
            Toast.makeText(this, R.string.not_connected, Toast.LENGTH_SHORT).show();
            return;
        }

        // Sprawdź czy jest cokolwiek do wysłania
        if (message.length() > 0) {
            // Pobierz komunikat i wyslij
            byte[] send = message.getBytes();
            mChatService.write(send);

            // Wyzeruj bufor 
            mOutStringBuffer.setLength(0);
            mOutEditText.setText(mOutStringBuffer);
        }
    }

    // Metoda nasłuchująca dla widżetu EditText
    private TextView.OnEditorActionListener mWriteListener =
        new TextView.OnEditorActionListener() {
        public boolean onEditorAction(TextView view, int actionId, KeyEvent event) {
            // Jeżeli puszczono klawisz return wyślij komunikat
            if (actionId == EditorInfo.IME_NULL && event.getAction() == KeyEvent.ACTION_UP) {
                String message = view.getText().toString();
                sendMessage(message);
            }
            if(D) Log.i(TAG, "END onEditorAction");
            return true;
        }
    };

    // Procedura odbierająca informacje z  BluetoothChatService
    private final Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
            case MESSAGE_STATE_CHANGE:
                if(D) Log.i(TAG, "MESSAGE_STATE_CHANGE: " + msg.arg1);
                switch (msg.arg1) {
                case BluetoothChatService.STATE_CONNECTED:
                    mTitle.setText(R.string.title_connected_to);
                    mTitle.append(mConnectedDeviceName);
                    mConversationArrayAdapter.clear();
                    break;
                case BluetoothChatService.STATE_CONNECTING:
                    mTitle.setText(R.string.title_connecting);
                    break;
                case BluetoothChatService.STATE_LISTEN:
                case BluetoothChatService.STATE_NONE:
                    mTitle.setText(R.string.title_not_connected);
                    break;
                }
                break;
            case MESSAGE_WRITE:
                byte[] writeBuf = (byte[]) msg.obj;
                // utwórz łańcuch z bufora
                String writeMessage = new String(writeBuf);
                mConversationArrayAdapter.add("Ja:  " + writeMessage);
                break;
            case MESSAGE_READ:
                byte[] readBuf = (byte[]) msg.obj;
                // utwórz łańcuch z bufora
                String readMessage = new String(readBuf, 0, msg.arg1);
                mConversationArrayAdapter.add(mConnectedDeviceName+":  " + readMessage);
                break;
            case MESSAGE_DEVICE_NAME:
                // zapisz nazwę połączonego urządzenia
                mConnectedDeviceName = msg.getData().getString(DEVICE_NAME);
                Toast.makeText(getApplicationContext(), "Podłączony do  "
                               + mConnectedDeviceName, Toast.LENGTH_SHORT).show();
                break;
            case MESSAGE_TOAST:
                Toast.makeText(getApplicationContext(), msg.getData().getString(TOAST),
                               Toast.LENGTH_SHORT).show();
                break;
            }
        }
    };

    public void onActivityResult(int requestCode, int resultCode, Intent data) {

        switch (requestCode) {
        case REQUEST_CONNECT_DEVICE:
            // Kiedy DeviceListActivity zwraca urządzenie do połączenia
            if (resultCode == Activity.RESULT_OK) {
                // pobierz adres MAC
                String address = data.getExtras()
                                     .getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
                // Pobierz obiekt BLuetoothDevice 
                BluetoothDevice device = BlueAdapter.getRemoteDevice(address);
                // Podejmij próbę połączenia
                mChatService.connect(device);
            }
            break;
        case REQUEST_ENABLE_BT:
            // Kiedy zakończy się żądanie włączenia Bluetooth
            if (resultCode == Activity.RESULT_OK) {
                // Bluetooth jest włączony zakończ sesję
                startgame();
            } else {
                // Użytkownik nie włączył Bluetooth lub wystąpił błąd
                Log.d(TAG, "Błąd inicjalizacji interfejsu Bluetooth");
                Toast.makeText(this, R.string.bt_not_enabled_leaving, Toast.LENGTH_SHORT).show();
                finish();
            }
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.option_menu, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
        case R.id.scan:
            // Uruchom  DeviceListActivity aby ujrzeć urządzenia do przeszukania
            Intent serverIntent = new Intent(this, DeviceListActivity.class);
            startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
            return true;
        case R.id.discoverable:
            // Upewnij się że urządzenie jest wykrywalne przez innych
            ensureDiscoverable();
            return true;
        }
        return false;
    }

}